"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setGlobalModels = setGlobalModels;
exports.setErrorHandler = setErrorHandler;
exports.default = withModels;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRedux = require("react-redux");

var _isFunction = _interopRequireDefault(require("lodash/isFunction"));

var _omit = _interopRequireDefault(require("lodash/omit"));

var _isArray = _interopRequireDefault(require("lodash/isArray"));

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var globalModels = {};
var errorHandler = null;

function setGlobalModels(models) {
  globalModels = Object.keys(models).reduce(function (globalModels, key) {
    return models[key].modelName === key ? _objectSpread(_objectSpread({}, globalModels), {}, _defineProperty({}, key, models[key])) : globalModels;
  }, {});
}

function setErrorHandler(value) {
  errorHandler = (0, _isFunction.default)(value) && value;
}

var Wrapper = /*#__PURE__*/function (_React$Component) {
  _inherits(Wrapper, _React$Component);

  var _super = _createSuper(Wrapper);

  function Wrapper() {
    _classCallCheck(this, Wrapper);

    return _super.apply(this, arguments);
  }

  _createClass(Wrapper, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this = this;

      var _this$props = this.props,
          _actions = _this$props._actions,
          dispatch = _this$props.dispatch,
          _handleError = _this$props._handleError;

      _actions.forEach( /*#__PURE__*/function () {
        var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
          var action;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  action = _ref.action;
                  _context.prev = 1;
                  _context.next = 4;
                  return dispatch(action);

                case 4:
                  _context.next = 9;
                  break;

                case 6:
                  _context.prev = 6;
                  _context.t0 = _context["catch"](1);

                  _handleError(_context.t0, _this.props);

                case 9:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, null, [[1, 6]]);
        }));

        return function (_x) {
          return _ref2.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(_ref3) {
      var _this2 = this;

      var actions = _ref3._actions;
      var _this$props2 = this.props,
          newActions = _this$props2._actions,
          dispatch = _this$props2.dispatch,
          _handleError = _this$props2._handleError;
      (newActions || []).filter(function (_ref4) {
        var name = _ref4.name,
            modelName = _ref4.modelName,
            actionName = _ref4.actionName,
            actionParams = _ref4.actionParams;
        return actions.findIndex(function (item) {
          return item.name === name && item.modelName === modelName && item.actionName === actionName && (0, _isEqual.default)(item.actionParams, actionParams);
        }) === -1;
      }).forEach( /*#__PURE__*/function () {
        var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref5) {
          var action;
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  action = _ref5.action;
                  _context2.prev = 1;
                  _context2.next = 4;
                  return dispatch(action);

                case 4:
                  _context2.next = 9;
                  break;

                case 6:
                  _context2.prev = 6;
                  _context2.t0 = _context2["catch"](1);

                  _handleError(_context2.t0, _this2.props);

                case 9:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, null, [[1, 6]]);
        }));

        return function (_x2) {
          return _ref6.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "render",
    value: function render() {
      var Component = this.props.Component;
      var props = (0, _omit.default)(this.props, 'Component', '_actions', '_handleError', 'state');
      return /*#__PURE__*/_react.default.createElement(Component, props);
    }
  }]);

  return Wrapper;
}(_react.default.Component);

Wrapper.propTypes = {
  Component: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.object]),
  _actions: _propTypes.default.array,
  dispatch: _propTypes.default.func
};

var emptyComponentProps = function emptyComponentProps() {
  return {};
};

function withModels(Component, componentProps) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var models = _objectSpread(_objectSpread({}, globalModels), Object.keys(options).reduce(function (models, key) {
    return options[key].modelName === key ? _objectSpread(_objectSpread({}, models), {}, _defineProperty({}, key, options[key])) : models;
  }, {}));

  var omitErrorsFor = options.omitErrorsFor;

  function _handleError(e, props, action) {
    var rules = omitErrorsFor;

    if (typeof omitErrorsFor === 'function') {
      rules = omitErrorsFor(props);
    }

    var omitError = rules && (0, _isArray.default)(rules) && rules.length > 0 && rules.findIndex(function (omitAction) {
      return (0, _isEqual.default)(omitAction, action);
    }) === -1;
    !omitError && errorHandler && errorHandler(e, props) || console.error(e);
  }

  var ConnectedComponent = (0, _reactRedux.connect)(function (state) {
    return state;
  }, null, function (stateProps, dispatchProps, props) {
    var allProps = (componentProps || emptyComponentProps)(_objectSpread(_objectSpread(_objectSpread({}, props), dispatchProps), {}, {
      state: stateProps
    })) || {};
    var actionKeys = Object.keys(allProps).filter(function (name) {
      return (0, _isFunction.default)(allProps[name]) && allProps[name].modelName;
    });

    var _actions = actionKeys.map(function (name) {
      return {
        name: name,
        action: allProps[name],
        modelName: allProps[name].modelName,
        actionName: allProps[name].actionName,
        actionParams: allProps[name].actionParams
      };
    });

    var actionsProps = _actions.reduce(function (props, _ref7) {
      var _objectSpread4;

      var name = _ref7.name,
          modelName = _ref7.modelName,
          actionName = _ref7.actionName,
          actionParams = _ref7.actionParams;
      var selectors = models[modelName](stateProps);
      var data = typeof selectors["".concat(actionName, "Meta")] === 'function' && selectors["".concat(actionName, "Meta")].apply(selectors, _toConsumableArray(actionParams)) || {};
      var result = typeof selectors[actionName] === 'function' && selectors[actionName].apply(selectors, _toConsumableArray(actionParams)) || null;
      return _objectSpread(_objectSpread({}, props), {}, (_objectSpread4 = {}, _defineProperty(_objectSpread4, name, result), _defineProperty(_objectSpread4, "".concat(name, "Requested"), data.requested === true), _defineProperty(_objectSpread4, "".concat(name, "Requesting"), data.requesting === true), _defineProperty(_objectSpread4, "".concat(name, "Error"), data.error), _objectSpread4));
    }, {});

    var restProps = (0, _omit.default)(allProps, actionKeys);
    return _objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread({}, dispatchProps), props), actionsProps), restProps), {}, {
      _actions: _actions,
      _handleError: _handleError,
      Component: Component
    });
  })(Wrapper);
  var componentName = Component.displayName || Component.name || 'Component';
  ConnectedComponent.displayName = "WithModels(".concat(componentName, ")");
  return ConnectedComponent;
}